SELF=$(basename $0)
-
help() {
echo "usage: $SELF <args>
[<repo>] Clone from an existing repository
help Display this help text
delete Delete an existing repository
- exit Exit repository; unset ENV
+ enter Enter repository; spawn new $SHELL
init <repo> Initialize a new repository
list List all repositories
run <repo> \\
seed-gitignore \\
<repo> Seed .gitignore.d/<repo> from git ls-files
- use <repo> Use repository; set ENV
+ setup Set up repository with recommended settings
<repo> <git command> Special command that allows you to run git commands
directly without having to type so much ;)" >&2
if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
}
-use() {
- verbose "use() begin"
- if [ ! -d "$GIT_DIR" ]; then
- echo E: no repository found for "$VCSH_REPO_NAME" >&2
- return 1
- fi
- export GIT_DIR
- export GIT_WORK_TREE="$(git config --get core.worktree)"
- export VCSH_DIRECTORY="$VCSH_REPO_NAME"
- verbose "use() end"
+setup() {
+ git config core.worktree "$GIT_WORK_TREE"
+ git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+ git config vcsh.vcsh 'true'
+ touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+ git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
}
init() {
return 1) || return $?
cd "$GIT_WORK_TREE"
git init
- git config core.worktree "$GIT_WORK_TREE"
- git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
- touch "$HOME/.gitignore.d/$VCSH_REPO_NAME"
- git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+ setup
verbose "init() end"
}
-leave() {
- unset GIT_DIR
- unset GIT_WORK_TREE
- unset VCSH_DIRECTORY
+use() {
+ verbose "use() begin"
+ if [ ! -d "$GIT_DIR" ]; then
+ echo E: no repository found for "$VCSH_REPO_NAME" >&2
+ return 1
+ fi
+ export GIT_DIR
+ export GIT_WORK_TREE="$(git config --get core.worktree)"
+ export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+ verbose "use() end"
}
if [ "$1" = 'clone' ]; then
+ export VCSH_COMMAND="$1"
GIT_REMOTE="$2"
export GIT_REMOTE
VCSH_REPO_NAME="$3"
export VCSH_REPO_NAME
export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
elif [ "$1" = 'delete' ] ||
+ [ "$1" = 'enter' ] ||
[ "$1" = 'init' ] ||
[ "$1" = 'run' ] ||
[ "$1" = 'seed-gitignore' ] ||
- [ "$1" = 'use' ]; then
+ [ "$1" = 'setup' ]; then
[ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
export VCSH_COMMAND="$1"
export VCSH_REPO_NAME="$2"
if [ "$VCSH_COMMAND" = 'run' ]; then
[ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
fi
-elif [ "$1" = 'exit' ] ||
- [ "$1" = 'help' ] ||
+elif [ "$1" = 'help' ] ||
[ "$1" = 'list' ]; then
export VCSH_COMMAND="$1"
else
echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
return 3
git merge origin/master
-# use || return $?
verbose "clone end"
#elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
cd "$old_dir"
verbose "delete end"
-elif [ "$VCSH_COMMAND" = 'exit' ]; then
- verbose "exit begin"
-# if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-# unset VCSH_NO_IGNORE_EOF
-# setopt NO_IGNORE_EOF
-# fi
- leave
-# [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
- verbose "exit end"
- return 0
+elif [ "$VCSH_COMMAND" = 'enter' ]; then
+ verbose "enter begin"
+ use || return $?
+ $SHELL
+ verbose "enter end"
elif [ "$VCSH_COMMAND" = 'init' ]; then
verbose "init begin"
init
-# use || return $?
verbose "init end"
elif [ "$VCSH_COMMAND" = 'list' ]; then
verbose "run begin"
use || return $?
$VCSH_EXTERNAL_COMMAND
- leave
verbose "run end"
elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
# Going back into old directory at the end in case `vcsh use` is reactivated.
old_dir="$PWD"
cd "$HOME"
- git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
gitignores=$(for file in $(git ls-files); do
while true; do
echo $file; new="${file%/*}"
cd "$old_dir"
verbose "seed-gitignore end"
-elif [ "$VCSH_COMMAND" = 'use' ]; then
- verbose "use begin"
-# if [ -n "$ZSH_VERSION" ]; then
-# if [ -o NO_IGNORE_EOF ]; then
-# export VCSH_NO_IGNORE_EOF=1
-# setopt IGNORE_EOF
-# fi
-# vcsh_exit() {
-# vcsh exit;
-# zle reset-prompt;
-# }
-# zle -N vcsh_exit
-# bindkey '^d' 'vcsh_exit'
-# fi
- use || return $?
-# [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
- verbose "use end"
+elif [ "$VCSH_COMMAND" = 'setup' ]; then
+ verbose "seed-gitignore begin"
+ use || return $?
+ setup || return $?
+ verbose "seed-gitignore end"
else
verbose "defaulting to calling help()"